#include <list>
#include "compareTest.h"

#include "compare/string/CyclicStringCompare.h"
#include "string/LinearString.h"

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_REGISTRATION( compareTest );

void compareTest::setUp() {
}

void compareTest::tearDown() {
}

void compareTest::testCyclicStringCompareBoolean() {
  string::LinearString str1("alfa");
  string::LinearString str2("aalf");
  str2.addSymbolsToAlphabet(str1.getAlphabet());
  str1.addSymbolsToAlphabet(str2.getAlphabet());
  
  CPPUNIT_ASSERT(compare::CyclicStringCompare::equals(str1, str2));
}

void compareTest::testCyclicStringCompareInt() {
  string::LinearString str1("alfa");
  string::LinearString str2("aalf");
  str2.addSymbolsToAlphabet(str1.getAlphabet());
  str1.addSymbolsToAlphabet(str2.getAlphabet());
  
  CPPUNIT_ASSERT(compare::CyclicStringCompare::compare(str1, str2) == 0);
}
