#include <sstream>

#include "RegExpIntegralTest.h"

#include "regexp/RegExpIntegral.h"

#include <regexp/RegExpFromStringParser.h>
#include <regexp/RegExpToStringComposer.h>
#include <string/StringFromStringParser.h>

#define CPPUNIT_IMPLY(x, y) CPPUNIT_ASSERT(!(x) || (y))

CPPUNIT_TEST_SUITE_REGISTRATION( RegExpIntegralTest );

void RegExpIntegralTest::setUp() {
}

void RegExpIntegralTest::tearDown() {
}

void RegExpIntegralTest::testRegExpIntegral() {
    // https://edux.fit.cvut.cz/oppa/BI-AAG/cviceni/aag-cv04.pdf

    // Exc. 16
    this->ExecSingleTest("010 + 101", "1", "1 0 1 0 + 1 1 0 1");
}

void RegExpIntegralTest::ExecSingleTest(std::string regexp_str, std::string string_str, std::string result) {
    std::stringstream regexp_ss(regexp_str);
    regexp::RegExpFromStringParser regexp_parser(regexp_ss);
    regexp::RegExp regexp = regexp_parser.parseValue();

    std::stringstream string_ss("\"" + string_str + "\"");
    string::StringFromStringParser string_parser(string_ss);
    string::String string = string_parser.parseValue();

    regexp::RegExpIntegral i;
    regexp::RegExpToStringComposer regexp_composer;

    // TODO
    // CPPUNIT_ASSERT(regexp_composer.compose(i.integral(regexp, string)) == result);
}
