/*
 * GrammarException.h
 *
 *  Created on: Apr 1, 2013
 *      Author: Martin Zak
 */

#ifndef GRAMMAR_EXCEPTION_H_
#define GRAMMAR_EXCEPTION_H_

#include "../exception/AlibException.h"

namespace grammar {

/**
 * Exception thrown by an grammar, grammar parser or grammar printer.
 */
class GrammarException: public exception::AlibException {
public:
	GrammarException();
	explicit GrammarException(const std::string& cause);
	virtual ~GrammarException() throw ();
};

} /* namespace grammar */

#endif /* GRAMMAR_EXCEPTION_H_ */
